@article{alenezi2015empirical,
	title={Empirical analysis of the complexity evolution in open-source software systems},
	author={Alenezi, Mamdouh and Almustafa, Khaled},
	journal={International Journal of Hybrid Information Technology},
	volume={8},
	number={2},
	pages={257--266},
	year={2015}
}

@article{banker1993software,
	title={Software complexity and maintenance costs},
	author={Banker, Rajiv D and Datar, Srikant M and Kemerer, Chris F and Zweig, Dani},
	journal={Communications of the ACM},
	volume={36},
	number={11},
	pages={81--95},
	year={1993},
	publisher={Association for Computing Machinery, Inc.}
}

@article{basili1983empirical,
	title={An empirical study of a syntactic complexity family},
	author={Basili, Victor R and Hutchens, David H},
	journal={Software Engineering, IEEE Transactions on},
	number={6},
	pages={664--672},
	year={1983},
	publisher={IEEE}
}

@article{balsamo2004model,
	title={Model-based performance prediction in software development: A survey},
	author={Balsamo, Simonetta and Marco, Antinisca Di and Inverardi, Paola and Simeoni, Marta},
	journal={Software Engineering, IEEE Transactions on},
	volume={30},
	number={5},
	pages={295--310},
	year={2004},
	publisher={IEEE}
}

@inproceedings{brown2010managing,
	title={Managing technical debt in software-reliant systems},
	author={Brown, Nanette and Cai, Yuanfang and Guo, Yuepu and Kazman, Rick and Kim, Miryung and Kruchten, Philippe and Lim, Erin and MacCormack, Alan and Nord, Robert and Ozkaya, Ipek and others},
	booktitle={Proceedings of the FSE/SDP workshop on Future of software engineering research},
	pages={47--52},
	year={2010},
	organization={ACM}
}

@article{briand1996property,
	title={Property-based software engineering measurement},
	author={Briand, Lionel C and Morasca, Sandro and Basili, Victor R},
	journal={Software Engineering, IEEE Transactions on},
	volume={22},
	number={1},
	pages={68--86},
	year={1996},
	publisher={IEEE}
}

@article{briand1999unified,
	title={A unified framework for coupling measurement in object-oriented systems},
	author={Briand, Lionel C and Daly, John W and W{\"u}st, J{\"u}rgen K},
	journal={Software Engineering, IEEE Transactions on},
	volume={25},
	number={1},
	pages={91--121},
	year={1999},
	publisher={IEEE}
}

@article{bunge1977treatise,
	title={Treatise on basic philosophy: Volume 3: Ontology 1: The furniture of the world},
	author={Bunge, Mario},
	journal={Reidel, Boston},
	pages={77},
	year={1977}
}

@misc{bunge1979world,
	title={A world of systems. Treatise on basic philosophy, Ontology 2},
	author={Bunge, M},
	year={1979},
	publisher={Dordrecht: Reidel Publishing Company}
}

@article{chidamber1994metrics,
	title={A metrics suite for object oriented design},
	author={Chidamber, Shyam R and Kemerer, Chris F},
	journal={Software Engineering, IEEE Transactions on},
	volume={20},
	number={6},
	pages={476--493},
	year={1994},
	publisher={IEEE}
}

@article{curtis1979measuring,
	title={Measuring the psychological complexity of software maintenance tasks with the Halstead and McCabe metrics},
	author={Curtis, Bill and Sheppard, Sylvia B and Milliman, Phil and Borst, MA and Love, Tom},
	journal={Software Engineering, IEEE Transactions on},
	number={2},
	pages={96--104},
	year={1979},
	publisher={IEEE}
}

@article{dijkstra1968letters,
	title={Letters to the editor: go to statement considered harmful},
	author={Dijkstra, Edsger W},
	journal={Communications of the ACM},
	volume={11},
	number={3},
	pages={147--148},
	year={1968},
	publisher={ACM}
}

@incollection{huang2014type,
	title={Type-based taint analysis for Java web applications},
	author={Huang, Wei and Dong, Yao and Milanova, Ana},
	booktitle={Fundamental Approaches to Software Engineering},
	pages={140--154},
	year={2014},
	publisher={Springer}
}

@article{fenton1999software,
	title={Software metrics: successes, failures and new directions},
	author={Fenton, Norman E and Neil, Martin},
	journal={Journal of Systems and Software},
	volume={47},
	number={2},
	pages={149--157},
	year={1999},
	publisher={Elsevier}
}

@inproceedings{fenton2000software,
	title={Software metrics: roadmap},
	author={Fenton, Norman E and Neil, Martin},
	booktitle={Proceedings of the Conference on the Future of Software Engineering},
	pages={357--370},
	year={2000},
	organization={ACM}
}

@book{fenton2014software,
	title={Software metrics: a rigorous and practical approach},
	author={Fenton, Norman and Bieman, James},
	year={2014},
	publisher={CRC Press}
}

@inproceedings{france2007model,
	title={Model-driven development of complex software: A research roadmap},
	author={France, Robert and Rumpe, Bernhard},
	booktitle={2007 Future of Software Engineering},
	pages={37--54},
	year={2007},
	organization={IEEE Computer Society}
}

@online{gnu2016whatis,
	author = {GNU},
	title = {What is free software?},
	date = {01-01-2016},
	url = {http://www.gnu.org/philosophy/free-sw.html},
	urldate = {2016-02-06},
}

@book{halstead1977elements,
	title={Elements of Software Science (Operating and programming systems series)},
	author={Halstead, Maurice H},
	year={1977},
	publisher={Elsevier Science Inc.}
}

@inproceedings{hassan2009predicting,
	title={Predicting faults using the complexity of code changes},
	author={Hassan, Ahmed E},
	booktitle={Proceedings of the 31st International Conference on Software Engineering},
	pages={78--88},
	year={2009},
	organization={IEEE Computer Society}
}

@article{hathawaytechniques,
	title={TECHNIQUES FOR COMPUTER-ASSISTED GRADING IN COMPUTER SCIENCE CURRICULA},
	author={Hathaway, Charles and Eglash, Ron and Krishnamoorthy, Mukkai}
}

@article{henry1981software,
	title={Software structure metrics based on information flow},
	author={Henry, Sallie and Kafura, Dennis},
	journal={Software Engineering, IEEE Transactions on},
	number={5},
	pages={510--518},
	year={1981},
	publisher={IEEE}
}

@article{ince1988approach,
	title={An approach to automated software design based on product metrics},
	author={Ince, DC and Hekmatpour, S},
	journal={Software Engineering Journal},
	volume={3},
	number={2},
	pages={53--56},
	year={1988},
	publisher={IET}
}

@article{kafura1987use,
	title={The use of software complexity metrics in software maintenance},
	author={Kafura, Dennis and Reddy, Geereddy R.},
	journal={IEEE Transactions on Software Engineering},
	volume={13},
	number={3},
	pages={335},
	year={1987},
	publisher={IEEE Computer Society}
}

@article{kearney1986software,
	title={Software complexity measurement},
	author={Kearney, Joseph P and Sedlmeyer, Robert L and Thompson, William B and Gray, Michael A and Adler, Michael A},
	journal={Communications of the ACM},
	volume={29},
	number={11},
	pages={1044--1050},
	year={1986},
	publisher={ACM}
}

@article{khoshgoftaar1990predicting,
	title={Predicting software development errors using software complexity metrics},
	author={Khoshgoftaar, Taghi M and Munson, John C},
	journal={Selected Areas in Communications, IEEE Journal on},
	volume={8},
	number={2},
	pages={253--261},
	year={1990},
	publisher={IEEE}
}

@inproceedings{kochhar2014empirical,
	title={An empirical study on the adequacy of testing in open source projects},
	author={Kochhar, Pavneet Singh and Thung, Ferdian and Lo, David and Lawall, Julia},
	booktitle={Software Engineering Conference (APSEC), 2014 21st Asia-Pacific},
	volume={1},
	pages={215--222},
	year={2014},
	organization={IEEE}
}

@article{li1993object,
	title={Object-oriented metrics that predict maintainability},
	author={Li, Wei and Henry, Sallie},
	journal={Journal of systems and software},
	volume={23},
	number={2},
	pages={111--122},
	year={1993},
	publisher={Elsevier}
}

@inproceedings{marinescu2005measurement,
	title={Measurement and quality in object-oriented design},
	author={Marinescu, Radu},
	booktitle={Software Maintenance, 2005. ICSM'05. Proceedings of the 21st IEEE International Conference on},
	pages={701--704},
	year={2005},
	organization={IEEE}
}

@article{mccabe1976complexity,
  title={A complexity measure},
  author={McCabe, Thomas J},
  journal={Software Engineering, IEEE Transactions on},
  number={4},
  pages={308--320},
  year={1976},
  publisher={IEEE}
}

@book{mitchell2009complexity,
	author = {Mitchell, Melaine},
	title = {Complexity a guided tour},
	year = {2009},
	publisher = {Oxford University Press, Inc},
	location = {Oxford, New York},
}

@article{nejmeh1988npath,
	title={NPATH: a measure of execution path complexity and its applications},
	author={Nejmeh, Brian A},
	journal={Communications of the ACM},
	volume={31},
	number={2},
	pages={188--200},
	year={1988},
	publisher={ACM}
}

@inproceedings{oviedo1993control,
	title={Control flow, data flow and program complexity},
	author={Oviedo, Enrique I},
	booktitle={Software engineering metrics I},
	pages={52--65},
	year={1993},
	organization={McGraw-Hill, Inc.}
}

@inproceedings{o2012experimental,
	title={Experimental assessment of software metrics using automated refactoring},
	author={{\'O} Cinn{\'e}ide, Mel and Tratt, Laurence and Harman, Mark and Counsell, Steve and Hemati Moghadam, Iman},
	booktitle={Proceedings of the ACM-IEEE international symposium on Empirical software engineering and measurement},
	pages={49--58},
	year={2012},
	organization={ACM}
}

@article{pendharkar2005probabilistic,
	title={A probabilistic model for predicting software development effort},
	author={Pendharkar, Parag C and Subramanian, Girish H and Rodger, James A},
	journal={Software Engineering, IEEE Transactions on},
	volume={31},
	number={7},
	pages={615--624},
	year={2005},
	publisher={IEEE}
}

@article{prather1984axiomatic,
	title={An axiomatic theory of software complexity measure},
	author={Prather, Ronald E.},
	journal={The Computer Journal},
	volume={27},
	number={4},
	pages={340--347},
	year={1984},
	publisher={Br Computer Soc}
}

@inproceedings{price2015comparing,
	title={Comparing Textual and Block Interfaces in a Novice Programming Environment},
	author={Price, Thomas W and Barnes, Tiffany},
	booktitle={Proceedings of the eleventh annual International Conference on International Computing Education Research},
	pages={91--99},
	year={2015},
	organization={ACM}
}

@article{shepperd1988critique,
	title={A critique of cyclomatic complexity as a software metric},
	author={Shepperd, Martin},
	journal={Software Engineering Journal},
	volume={3},
	number={2},
	pages={30--36},
	year={1988},
	publisher={IET}
}

@inproceedings{shepperd1990multi,
	title={Multi-dimensional modelling and measurement of software designs},
	author={Shepperd, Martin and Ince, Darrel},
	booktitle={Proceedings of the 1990 ACM annual conference on Cooperation},
	pages={76--81},
	year={1990},
	organization={ACM}
}

@article{subramanyam2003empirical,
	title={Empirical analysis of ck metrics for object-oriented design complexity: Implications for software defects},
	author={Subramanyam, Ramanath and Krishnan, Mayuram S.},
	journal={Software Engineering, IEEE Transactions on},
	volume={29},
	number={4},
	pages={297--310},
	year={2003},
	publisher={IEEE}
}

@article{tao2014complexity,
	title={Complexity measure based on program slicing and its validation},
	author={Tao, Hongwei and Chen, Yixiang},
	journal={Wuhan University Journal of Natural Sciences},
	volume={19},
	number={6},
	pages={512--518},
	year={2014},
	publisher={Springer}
}

@article{wand1990ontological,
	title={An ontological model of an information system},
	author={Wand, Yair and Weber, Ron},
	journal={Software Engineering, IEEE Transactions on},
	volume={16},
	number={11},
	pages={1282--1292},
	year={1990},
	publisher={IEEE}
}

@article{weyuker1988evaluating,
	title={Evaluating software complexity measures},
	author={Weyuker, Elaine J},
	journal={Software Engineering, IEEE Transactions on},
	volume={14},
	number={9},
	pages={1357--1365},
	year={1988},
	publisher={IEEE}
}

@book{wolfgang1994design,
	title={Design patterns for object-oriented software development},
	author={Wolfgang, Pree},
	year={1994},
	publisher={Reading, Mass.: Addison-Wesley}
}

@article{woodward1979measure,
	title={A measure of control flow complexity in program text},
	author={Woodward, Martin R and Hennell, Michael and Hedley, David and others},
	journal={Software Engineering, IEEE Transactions on},
	number={1},
	pages={45--50},
	year={1979},
	publisher={IEEE}
}

@inproceedings{yin1978establishment,
	title={The establishment and use of measures to evaluate the quality of software designs},
	author={Yin, BH and Winchester, JW},
	booktitle={ACM SIGSOFT Software Engineering Notes},
	volume={3},
	number={5},
	pages={45--52},
	year={1978},
	organization={ACM}
}
